From 38cd4a0fda5b963611a212b4debc0c9aa1c61538 Mon Sep 17 00:00:00 2001
From: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Date: Sat, 23 May 2020 20:41:49 +0900
Subject: [PATCH] Change from python2 code to python3

The original patch was took from:
  https://github.com/google/mozc/issues/462
  https://github.com/google/mozc/files/4048079/mozc-2.23.2815.102-python-3.patch.txt

Signed-off-by: Nobuhiro Iwamatsu <iwamatsu@debian.org>
---
 src/android/gen_emoji_data.py                 | 224 +++++++++---------
 src/android/gen_emoticon_data.py              |  23 +-
 src/android/gen_mozc_drawable.py              |  10 +-
 src/android/gen_touch_event_stats.py          |   8 +-
 src/android/run_android_test.py               |  17 +-
 src/base/gen_character_set.py                 |  13 +-
 src/base/gen_config_file_stream_data.py       |   6 +-
 src/build_mozc.py                             |  20 +-
 src/build_tools/android_util.py               |   6 +-
 src/build_tools/binary_size_checker.py        |   8 +-
 src/build_tools/build_and_sign_pkg_mac.py     |   4 +-
 src/build_tools/build_breakpad.py             |   4 +-
 src/build_tools/build_diskimage_mac.py        |   2 +-
 src/build_tools/change_reference_mac.py       |   4 +-
 src/build_tools/code_generator_util.py        |  49 ++--
 src/build_tools/codesign_mac.py               |  26 +-
 src/build_tools/copy_dll_and_symbol.py        |   4 +-
 src/build_tools/copy_file.py                  |   2 +-
 src/build_tools/copy_qt_frameworks_mac.py     |   6 +-
 src/build_tools/embed_file.py                 |  38 +--
 src/build_tools/embed_pathname.py             |   6 +-
 src/build_tools/ensure_gyp_module_path.py     |  12 +-
 src/build_tools/gen_win32_resource_header.py  |   2 +-
 src/build_tools/mozc_version.py               |  17 +-
 src/build_tools/redirect.py                   |   7 +-
 src/build_tools/run_after_chdir.py            |   2 +-
 .../serialized_string_array_builder.py        |   6 +-
 src/build_tools/test_tools/gtest_report.py    |  10 +-
 src/build_tools/test_tools/test_launcher.py   |   5 +-
 src/build_tools/tweak_data.py                 |   2 +-
 src/build_tools/tweak_info_plist.py           |   6 +-
 src/build_tools/tweak_info_plist_strings.py   |   4 +-
 src/build_tools/tweak_macinstaller_script.py  |   2 +-
 src/build_tools/tweak_pkgproj.py              |   4 +-
 src/build_tools/util.py                       |   6 +-
 src/build_tools/zlib_util.py                  |   4 +-
 src/chrome/nacl/nacl_net_test_server.py       |  49 ++--
 src/chrome/nacl/pnacl_translate.py            |  24 +-
 src/chrome/nacl/run_nacl_test.py              |   2 +-
 src/client/gen_client_quality_test_data.py    |  44 ++--
 src/composer/internal/gen_typing_model.py     |  19 +-
 src/converter/gen_boundary_data.py            |  16 +-
 .../gen_quality_regression_test_data.py       |  22 +-
 src/converter/gen_segmenter_code.py           |  25 +-
 src/data/test/calculator/gen_test.py          |  64 +++--
 src/data_manager/gen_connection_data.py       |  33 ++-
 src/dictionary/gen_pos_map.py                 |  18 +-
 src/dictionary/gen_pos_rewrite_rule.py        |  19 +-
 src/dictionary/gen_suffix_data.py             |   8 +-
 src/dictionary/gen_user_pos_data.py           |   4 +-
 src/dictionary/gen_zip_code_seed.py           |  22 +-
 src/dictionary/zip_code_util.py               |  10 +-
 src/gui/character_pad/data/gen_cp932_map.py   |  26 +-
 .../data/gen_local_character_map.py           |  27 ++-
 .../character_pad/data/gen_unicode_blocks.py  |  15 +-
 .../character_pad/data/gen_unicode_data.py    |  21 +-
 src/gui/character_pad/data/gen_unihan_data.py |  43 ++--
 src/mac/generate_mapping.py                   |  36 +--
 src/prediction/gen_zero_query_data.py         |  50 ++--
 src/prediction/gen_zero_query_number_data.py  |  10 +-
 src/prediction/gen_zero_query_util.py         |   2 +-
 src/rewriter/gen_counter_suffix_array.py      |   2 +-
 src/rewriter/gen_emoji_rewriter_data.py       |  40 ++--
 src/rewriter/gen_reading_correction_data.py   |   4 +-
 .../gen_single_kanji_rewriter_data.py         |   8 +-
 src/session/gen_session_stress_test_data.py   |  18 +-
 src/unix/ibus/gen_mozc_xml.py                 |  42 ++--
 src/usage_stats/gen_stats_list.py             |  21 +-
 src/win32/installer/postbuilds_win.py         |  16 +-
 69 files changed, 685 insertions(+), 644 deletions(-)

diff --git a/src/android/gen_emoji_data.py b/src/android/gen_emoji_data.py
index 8a351272..385a030a 100644
--- a/src/android/gen_emoji_data.py
+++ b/src/android/gen_emoji_data.py
@@ -48,23 +48,23 @@ from build_tools import code_generator_util
 # We assign 100,000 and greater values for carrier emoji, so "offset" should be
 # less than 100,000.
 _CATEGORY_MAP = {
-  'SMILEY_PEOPLE': {'category': 'FACE', 'offset': 0},
-  'ANIMALS_NATURE': {'category': 'FOOD', 'offset': 0},
-  'FOOD_DRINK': {'category': 'FOOD', 'offset': 10000},
-  'TRAVEL_PLACES': {'category': 'CITY', 'offset': 0},
-  'ACTIVITY': {'category': 'ACTIVITY', 'offset': 0},
-  'OBJECTS': {'category': 'ACTIVITY', 'offset': 10000},
-  'SYMBOLS': {'category': 'NATURE', 'offset': 0},
-  'FLAGS': {'category': 'NATURE', 'offset': 10000},
+  b'SMILEY_PEOPLE': {'category': b'FACE', 'offset': 0},
+  b'ANIMALS_NATURE': {'category': b'FOOD', 'offset': 0},
+  b'FOOD_DRINK': {'category': b'FOOD', 'offset': 10000},
+  b'TRAVEL_PLACES': {'category': b'CITY', 'offset': 0},
+  b'ACTIVITY': {'category': b'ACTIVITY', 'offset': 0},
+  b'OBJECTS': {'category': b'ACTIVITY', 'offset': 10000},
+  b'SYMBOLS': {'category': b'NATURE', 'offset': 0},
+  b'FLAGS': {'category': b'NATURE', 'offset': 10000},
 }
-_CATEGORY_LIST = list(set(
-    [entry['category'] for entry in _CATEGORY_MAP.itervalues()]))
+_CATEGORY_LIST = sorted(set(
+    [entry['category'] for entry in _CATEGORY_MAP.values()]))
 
 
 def ReadData(stream):
   category_map = defaultdict(list)
   stream = code_generator_util.SkipLineComment(stream)
-  stream = code_generator_util.ParseColumnStream(stream, delimiter='\t')
+  stream = code_generator_util.ParseColumnStream(stream, delimiter=b'\t')
   stream = code_generator_util.SelectColumn(stream, [0, 2, 8, 9, 10, 11, 12])
   for (code, pua_code, japanese_name, docomo_name, softbank_name, kddi_name,
        category_index) in stream:
@@ -76,19 +76,19 @@ def ReadData(stream):
       sys.exit(-1)
     if not code:
       # Use dummy code point
-      code = '0'
+      code = b'0'
     if not pua_code:
       # Use dummy code point
-      pua_code = '0'
-    if pua_code[0] == '>':
+      pua_code = b'0'
+    if pua_code[0:1] == b'>':
       # Don't skip entires which has non-primary PUA codepoint since they also
       # has unique Unicode codepoint.
       # e.g. "BLACK SQUARE BUTTON" and "LARGE BLUE CIRCLE"
       pua_code = pua_code[1:]
 
-    code_values = [int(c, 16) for c in re.split(r' +', code.strip())]
+    code_values = [int(c, 16) for c in re.split(br' +', code.strip())]
     pua_code_value = int(pua_code, 16)
-    (category, index) = category_index.split('-')
+    (category, index) = category_index.split(b'-')
     index = int(index) + _CATEGORY_MAP[category]['offset']
     category = _CATEGORY_MAP[category]['category']
     category_map[category].append(
@@ -98,92 +98,92 @@ def ReadData(stream):
 
 
 _CHARACTER_NORMALIZE_MAP = {
-    u'Ａ': 'A',
-    u'Ｂ': 'B',
-    u'Ｃ': 'C',
-    u'Ｄ': 'D',
-    u'Ｅ': 'E',
-    u'Ｆ': 'F',
-    u'Ｇ': 'G',
-    u'Ｈ': 'H',
-    u'Ｉ': 'I',
-    u'Ｊ': 'J',
-    u'Ｋ': 'K',
-    u'Ｌ': 'L',
-    u'Ｍ': 'M',
-    u'Ｎ': 'N',
-    u'Ｏ': 'O',
-    u'Ｐ': 'P',
-    u'Ｑ': 'Q',
-    u'Ｒ': 'R',
-    u'Ｓ': 'S',
-    u'Ｔ': 'T',
-    u'Ｕ': 'U',
-    u'Ｖ': 'V',
-    u'Ｗ': 'W',
-    u'Ｘ': 'X',
-    u'Ｙ': 'Y',
-    u'Ｚ': 'Z',
-
-    u'ａ': 'a',
-    u'ｂ': 'b',
-    u'ｃ': 'c',
-    u'ｄ': 'd',
-    u'ｅ': 'e',
-    u'ｆ': 'f',
-    u'ｇ': 'g',
-    u'ｈ': 'h',
-    u'ｉ': 'i',
-    u'ｊ': 'j',
-    u'ｋ': 'k',
-    u'ｌ': 'l',
-    u'ｍ': 'm',
-    u'ｎ': 'n',
-    u'ｏ': 'o',
-    u'ｐ': 'p',
-    u'ｑ': 'q',
-    u'ｒ': 'r',
-    u'ｓ': 's',
-    u'ｔ': 't',
-    u'ｕ': 'u',
-    u'ｖ': 'v',
-    u'ｗ': 'w',
-    u'ｘ': 'x',
-    u'ｙ': 'y',
-    u'ｚ': 'z',
-
-    u'０': '0',
-    u'１': '1',
-    u'２': '2',
-    u'３': '3',
-    u'４': '4',
-    u'５': '5',
-    u'６': '6',
-    u'７': '7',
-    u'８': '8',
-    u'９': '9',
-
-    u'（': '(',
-    u'）': ')',
+    'Ａ': 'A',
+    'Ｂ': 'B',
+    'Ｃ': 'C',
+    'Ｄ': 'D',
+    'Ｅ': 'E',
+    'Ｆ': 'F',
+    'Ｇ': 'G',
+    'Ｈ': 'H',
+    'Ｉ': 'I',
+    'Ｊ': 'J',
+    'Ｋ': 'K',
+    'Ｌ': 'L',
+    'Ｍ': 'M',
+    'Ｎ': 'N',
+    'Ｏ': 'O',
+    'Ｐ': 'P',
+    'Ｑ': 'Q',
+    'Ｒ': 'R',
+    'Ｓ': 'S',
+    'Ｔ': 'T',
+    'Ｕ': 'U',
+    'Ｖ': 'V',
+    'Ｗ': 'W',
+    'Ｘ': 'X',
+    'Ｙ': 'Y',
+    'Ｚ': 'Z',
+
+    'ａ': 'a',
+    'ｂ': 'b',
+    'ｃ': 'c',
+    'ｄ': 'd',
+    'ｅ': 'e',
+    'ｆ': 'f',
+    'ｇ': 'g',
+    'ｈ': 'h',
+    'ｉ': 'i',
+    'ｊ': 'j',
+    'ｋ': 'k',
+    'ｌ': 'l',
+    'ｍ': 'm',
+    'ｎ': 'n',
+    'ｏ': 'o',
+    'ｐ': 'p',
+    'ｑ': 'q',
+    'ｒ': 'r',
+    'ｓ': 's',
+    'ｔ': 't',
+    'ｕ': 'u',
+    'ｖ': 'v',
+    'ｗ': 'w',
+    'ｘ': 'x',
+    'ｙ': 'y',
+    'ｚ': 'z',
+
+    '０': '0',
+    '１': '1',
+    '２': '2',
+    '３': '3',
+    '４': '4',
+    '５': '5',
+    '６': '6',
+    '７': '7',
+    '８': '8',
+    '９': '9',
+
+    '（': '(',
+    '）': ')',
 }
 
 
 def PreprocessName(name):
   if not name:
-    return 'null'
-  name = unicode(name, 'utf-8')
-  name = u''.join(_CHARACTER_NORMALIZE_MAP.get(c, c) for c in name)
+    return b'null'
+  name = str(name, 'utf-8')
+  name = ''.join(_CHARACTER_NORMALIZE_MAP.get(c, c) for c in name)
   name = name.encode('utf-8')
-  name = name.replace('(', '\\n(')
-  return '"%s"' % name
+  name = name.replace(b'(', b'\\n(')
+  return b'"%b"' % name
 
 
 def OutputData(category_map, stream):
-  for data_list in category_map.itervalues():
+  for data_list in category_map.values():
     data_list.sort()
 
-  stream.write('package org.mozc.android.inputmethod.japanese.emoji;\n'
-               'public class EmojiData {\n')
+  stream.write(b'package org.mozc.android.inputmethod.japanese.emoji;\n'
+               b'public class EmojiData {\n')
 
   for category in _CATEGORY_LIST:
     # The content of data list is
@@ -197,45 +197,45 @@ def OutputData(category_map, stream):
     data_list = [c for c in category_map[category]
                  if c[3] or c[4] or c[5] or c[6]]
     stream.write(
-        '  public static final String[] %s_VALUES = new String[]{\n' %
+        b'  public static final String[] %b_VALUES = new String[]{\n' %
         category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
-      stream.write('    %s,\n' % code_generator_util.ToJavaStringLiteral(codes))
-    stream.write('  };\n')
+      stream.write(b'    %b,\n' % code_generator_util.ToJavaStringLiteral(codes))
+    stream.write(b'  };\n')
 
     stream.write(
-        '  public static final String[] %s_PUA_VALUES = new String[]{\n' %
+        b'  public static final String[] %b_PUA_VALUES = new String[]{\n' %
         category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
       stream.write(
-          '    %s,\n' % code_generator_util.ToJavaStringLiteral(pua_code))
-    stream.write('  };\n')
+          b'    %b,\n' % code_generator_util.ToJavaStringLiteral(pua_code))
+    stream.write(b'  };\n')
 
     stream.write(
-        '  public static final String[] UNICODE_%s_NAME = {\n' % category)
+        b'  public static final String[] UNICODE_%b_NAME = {\n' % category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
-      stream.write('    %s, \n' % PreprocessName(japanese))
-    stream.write('  };\n')
+      stream.write(b'    %b, \n' % PreprocessName(japanese))
+    stream.write(b'  };\n')
 
     stream.write(
-        '  public static final String[] DOCOMO_%s_NAME = {\n' % category)
+        b'  public static final String[] DOCOMO_%b_NAME = {\n' % category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
-      stream.write('    %s, \n' % PreprocessName(docomo))
-    stream.write('  };\n')
+      stream.write(b'    %b, \n' % PreprocessName(docomo))
+    stream.write(b'  };\n')
 
     stream.write(
-        '  public static final String[] SOFTBANK_%s_NAME = {\n' % category)
+        b'  public static final String[] SOFTBANK_%b_NAME = {\n' % category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
-      stream.write('    %s, \n' % PreprocessName(softbank))
-    stream.write('  };\n')
+      stream.write(b'    %b, \n' % PreprocessName(softbank))
+    stream.write(b'  };\n')
 
     stream.write(
-        '  public static final String[] KDDI_%s_NAME = {\n' % category)
+        b'  public static final String[] KDDI_%b_NAME = {\n' % category)
     for _, codes, pua_code, japanese, docomo, softbank, kddi in data_list:
-      stream.write('    %s, \n' % PreprocessName(kddi))
-    stream.write('  };\n')
+      stream.write(b'    %b, \n' % PreprocessName(kddi))
+    stream.write(b'  };\n')
 
-  stream.write('}\n')
+  stream.write(b'}\n')
 
 
 def ParseOptions():
@@ -248,10 +248,10 @@ def ParseOptions():
 
 def main():
   options = ParseOptions()
-  with open(options.emoji_data) as stream:
+  with open(options.emoji_data, 'rb') as stream:
     emoji_data = ReadData(stream)
 
-  with open(options.output, 'w') as stream:
+  with open(options.output, 'wb') as stream:
     OutputData(emoji_data, stream)
 
 
diff --git a/src/android/gen_emoticon_data.py b/src/android/gen_emoticon_data.py
index 5e6878b6..310e5e8e 100644
--- a/src/android/gen_emoticon_data.py
+++ b/src/android/gen_emoticon_data.py
@@ -38,7 +38,6 @@ The first line of .tsv file is ignored because it is used as label.
 
 __author__ = "matsuzakit"
 
-import io
 import optparse
 import sys
 import unicodedata
@@ -58,7 +57,8 @@ def ParseSymbolFile(file_name, value_column, category_column,
   """Parses symbol file and returns tag->symbols dictionary."""
   tag2symbol = {}
   is_first_line = True
-  for line in io.open(file_name, encoding='utf-8'):
+  file = open(file_name, encoding='utf-8')
+  for line in file:
     line_parts = line.rstrip().split('\t')
     if is_first_line:
       # Skip the first line, which is used as label.
@@ -77,6 +77,7 @@ def ParseSymbolFile(file_name, value_column, category_column,
       tag2symbol.setdefault(tag, []).append(symbol)
       if tag in expand_variant_tags and symbol != normalized:
         tag2symbol[tag].append(normalized)
+  file.close()
 
   return tag2symbol
 
@@ -110,7 +111,7 @@ def GetStringArrayOfSymbols(tag_name, original_symbols, ordering_rule_list):
   else:
     symbols = original_symbols
 
-  _ESCAPE = (u'"', u'\\')
+  _ESCAPE = ('"', '\\')
   for symbol in symbols:
     # Escape characters (defined above) have to be escaped by backslashes.
     # e.g.
@@ -125,7 +126,7 @@ def GetStringArrayOfSymbols(tag_name, original_symbols, ordering_rule_list):
     #   which include '\u0022' will terminate here.
     # They are not what we want so before such characters we place '\'
     # in order to escape them.
-    line = ['%s\\u%04x' % ('' if c not in _ESCAPE else '\u005c', ord(c))
+    line = ['%s\\u%04x' % ('' if c not in _ESCAPE else '\\u005c', ord(c))
             for c in symbol]
     # The white space is quick fix for the backslash at the tail of symbol.
     lines.append('    "%s",  // %s ' % (''.join(line), symbol))
@@ -135,8 +136,8 @@ def GetStringArrayOfSymbols(tag_name, original_symbols, ordering_rule_list):
 
 def WriteOut(output, tag2symbol, class_name, ordering_rule_list):
   body = [GetStringArrayOfSymbols(tag, symbols, ordering_rule_list)
-          for tag, symbols in tag2symbol.iteritems()]
-  with io.open(output, 'w', encoding='utf-8') as out_file:
+          for tag, symbols in sorted(tag2symbol.items())]
+  with open(output, 'w', encoding='utf-8') as out_file:
     out_file.write(TEMPLATE_CLASS % (PACKAGE_NAME, class_name, '\n'.join(body)))
 
 
@@ -162,12 +163,14 @@ def ParseOption():
 
 def CreateOrderingRuleList(file_name):
   ordering_rule_list = []
-  for line in io.open(file_name, encoding='utf-8'):
+  file = open(file_name, encoding='utf-8')
+  for line in file:
     # Do not forget such line of which content is ' '.
     # Such line has to be appended into the list.
-    if not line.startswith(u'# ') and not line.startswith(u'\n'):
-      value = line.rstrip(u'\r\n')
+    if not line.startswith('# ') and not line.startswith('\n'):
+      value = line.rstrip('\r\n')
       ordering_rule_list.append(value)
+  file.close()
   return ordering_rule_list
 
 
@@ -176,7 +179,7 @@ def main():
   if not (options.input and options.output and options.class_name and
           options.value_column is not None and
           options.category_column is not None):
-    print 'Some options cannot be omitted. See --help.'
+    print('Some options cannot be omitted. See --help.')
     sys.exit(1)
   tag2symbol = ParseSymbolFile(options.input,
                                options.value_column,
diff --git a/src/android/gen_mozc_drawable.py b/src/android/gen_mozc_drawable.py
index f3e4cbb4..0a738f95 100644
--- a/src/android/gen_mozc_drawable.py
+++ b/src/android/gen_mozc_drawable.py
@@ -41,14 +41,14 @@ and it'd cause an crash error, unfortunately.
 
 __author__ = "hidehiko"
 
-import cStringIO as StringIO
+import io
 import logging
 import optparse
 import os
 import re
 import struct
 import sys
-from xml.etree import cElementTree as ElementTree
+from xml.etree import ElementTree
 
 from build_tools import util
 
@@ -289,7 +289,7 @@ class MozcDrawableConverter(object):
   def _ConsumeFloatList(self, s, num):
     """Parses num floating values from s."""
     result = []
-    for _ in xrange(num):
+    for _ in range(num):
       value, s = self._ConsumeFloat(s)
       result.append(value)
     return result, s
@@ -1035,12 +1035,12 @@ class MozcDrawableConverter(object):
 
   # Interface for drawable conversion.
   def ConvertPictureDrawable(self, path):
-    output = _OutputStream(StringIO.StringIO())
+    output = _OutputStream(io.BytesIO())
     self._ConvertPictureDrawableInternal(ElementTree.parse(path), output)
     return output.output.getvalue()
 
   def ConvertStateListDrawable(self, drawable_source_list):
-    output = _OutputStream(StringIO.StringIO())
+    output = _OutputStream(io.BytesIO())
     output.WriteByte(DRAWABLE_STATE_LIST)
     output.WriteByte(len(drawable_source_list))
     for (state_list, path) in drawable_source_list:
diff --git a/src/android/gen_touch_event_stats.py b/src/android/gen_touch_event_stats.py
index 4916666f..9edfc31b 100644
--- a/src/android/gen_touch_event_stats.py
+++ b/src/android/gen_touch_event_stats.py
@@ -43,7 +43,7 @@ import csv
 import optparse
 import os
 import struct
-import urllib
+import urllib.parse
 
 
 def ReadCollectedKeyboards(stream):
@@ -112,7 +112,7 @@ def WriteKeyboardData(keyboard_value, stream):
   # c.f. usage_stats/usage_stats_uploader.cc
   keys = ('sxa', 'sya', 'sxv', 'syv', 'dxa', 'dya', 'dxv', 'dyv')
   stream.write(struct.pack('>i', len(keyboard_value)))
-  for source_id, source_value in keyboard_value.iteritems():
+  for source_id, source_value in sorted(keyboard_value.items()):
     stream.write(struct.pack('>i', source_id))
     # Note that we are calculating
     # "Average of average" and "Average of variance".
@@ -124,10 +124,10 @@ def WriteKeyboardData(keyboard_value, stream):
 
 
 def WriteData(stats, output_dir):
-  for base_name_orientation in stats.iterkeys():
+  for base_name_orientation in stats.keys():
     with open(os.path.join(output_dir,
                            '%s_%s.touch_stats' % (
-                               urllib.unquote(base_name_orientation[0]),
+                               urllib.parse.unquote(base_name_orientation[0]),
                                base_name_orientation[1])),
               'wb') as stream:
       WriteKeyboardData(stats[base_name_orientation], stream)
diff --git a/src/android/run_android_test.py b/src/android/run_android_test.py
index ebb98638..79865a51 100644
--- a/src/android/run_android_test.py
+++ b/src/android/run_android_test.py
@@ -44,8 +44,9 @@ import multiprocessing
 import optparse
 import os
 import subprocess
+import sys
 import time
-from xml.etree import cElementTree as ElementTree
+from xml.etree import ElementTree
 from build_tools import android_util
 from build_tools.test_tools import gtest_report
 
@@ -142,9 +143,9 @@ def AppendPrefixToSuiteName(in_file_name, out_file_name, prefix):
     AppendPrefix(root)
   for elem in root.findall('testsuite'):
     AppendPrefix(elem)
-  with open(out_file_name, 'w') as f:
+  with open(out_file_name, 'wb') as f:
     # Note that ElementTree of 2.6 doesn't write XML declaration.
-    f.write('<?xml version="1.0" encoding="utf-8"?>\n')
+    f.write(b'<?xml version="1.0" encoding="utf-8"?>\n')
     f.write(ElementTree.tostring(root, 'utf-8'))
 
 
@@ -156,7 +157,7 @@ class AndroidDevice(android_util.AndroidDevice):
     """Wait until SD card is mounted."""
     retry = 10
     sleep = 30
-    for _ in xrange(retry):
+    for _ in range(retry):
       if self._RunCommand('mount').find('/sdcard') != -1:
         self.GetLogger().info('SD card has been mounted.')
         return
@@ -458,7 +459,7 @@ def main():
 
   if not options.android_home:
     logging.error('--android_home option must be specified.')
-    os.exit(1)
+    sys.exit(1)
 
   if options.run_native_test:
     binaries = FindTestBinaries(options.test_bin_dir)
@@ -501,11 +502,11 @@ def main():
   # result.get() blocks until the test terminates.
   error_messages = [result.get() for result in results if result.get()]
   if error_messages:
-    print '[FAIL] Native tests result : Test failures are found;'
+    print('[FAIL] Native tests result : Test failures are found;')
     for message in error_messages:
-      print message
+      print(message)
   else:
-    print '[ OK ] Native tests result : Tests scceeded.'
+    print('[ OK ] Native tests result : Tests scceeded.')
 
 
 if __name__ == '__main__':
diff --git a/src/base/gen_character_set.py b/src/base/gen_character_set.py
index bb39c472..7ac5b522 100644
--- a/src/base/gen_character_set.py
+++ b/src/base/gen_character_set.py
@@ -33,7 +33,6 @@ __author__ = "taku"
 import itertools
 import optparse
 import re
-import string
 import sys
 
 
@@ -89,7 +88,8 @@ class CodePointCategorizer(object):
   @staticmethod
   def _LoadTable(filename, column_index, pattern, validater):
     result = set()
-    for line in open(filename):
+    fh = open(filename)
+    for line in fh:
       if line.startswith('#'):
         # Skip a comment line.
         continue
@@ -100,6 +100,7 @@ class CodePointCategorizer(object):
         ucs = int(match.group(1), 16)
         if validater(ucs):
           result.add(ucs)
+    fh.close()
 
     return result
 
@@ -250,7 +251,7 @@ def GenerateCategoryBitmap(category_list, name):
   # (at most) four code points.
   bit_list = []
   for _, group in itertools.groupby(enumerate(category_list),
-                                    lambda (codepoint, _): codepoint / 4):
+                                    lambda x: x[0] // 4):
     # Fill bits from LSB to MSB for each group.
     bits = 0
     for index, (_, category) in enumerate(group):
@@ -263,7 +264,7 @@ def GenerateCategoryBitmap(category_list, name):
 
   # Output the content. Each line would have (at most) 16 bytes.
   for _, group in itertools.groupby(enumerate(bit_list),
-                                    lambda (index, _): index / 16):
+                                    lambda x: x[0] // 16):
     line = ['    \"']
     for _, bits in group:
       line.append('\\x%02X' % bits)
@@ -386,7 +387,7 @@ def GenerateGetCharacterSet(category_list, bitmap_name, bitmap_size):
   # Bitmap lookup.
   # TODO(hidehiko): the bitmap has two huge 0-bits ranges. Reduce them.
   category_map = [
-      (bits, category) for category, bits in CATEGORY_BITMAP.iteritems()]
+      (bits, category) for category, bits in CATEGORY_BITMAP.items()]
   category_map.sort()
 
   lines.extend([
@@ -451,7 +452,7 @@ def main():
                                      options.jisx0213file)
   category_list = [
       categorizer.GetCategory(codepoint)
-      for codepoint in xrange(categorizer.MaxCodePoint() + 1)]
+      for codepoint in range(categorizer.MaxCodePoint() + 1)]
   generated_character_set_header = GenerateCharacterSetHeader(category_list)
 
   # Write the result.
diff --git a/src/base/gen_config_file_stream_data.py b/src/base/gen_config_file_stream_data.py
index 2a7af1a2..53832d18 100644
--- a/src/base/gen_config_file_stream_data.py
+++ b/src/base/gen_config_file_stream_data.py
@@ -58,7 +58,7 @@ def GenerateFileData(path):
   result = []
   result.append(' { "%s",  "' % os.path.basename(path))
   with open(path, 'rb') as stream:
-    result.extend(r'\x%02X' % ord(byte) for byte in stream.read())
+    result.extend(r'\x%02X' % byte for byte in stream.read())
   result.append('",  %d }' % os.path.getsize(path))
 
   return ''.join(result)
@@ -93,8 +93,8 @@ def OutputConfigFileStreamData(path_list, output):
 def main():
   (options, args) = ParseOptions()
   if not options.output:
-    print >>sys.stderr, (
-        'usage: gen_config_file_stream_data.py --output=filepath input ...')
+    print('usage: gen_config_file_stream_data.py --output=filepath input ...',
+          file=sys.stderr)
     sys.exit(2)
 
   with open(options.output, 'w') as output:
diff --git a/src/build_mozc.py b/src/build_mozc.py
index 46fa0827..89d9c939 100644
--- a/src/build_mozc.py
+++ b/src/build_mozc.py
@@ -943,7 +943,7 @@ def RunTests(target_platform, configuration, parallel_num):
       logging.info('running %s...', binary)
       try:
         test_function(binary, gtest_report_dir, options)
-      except RunOrDieError, e:
+      except RunOrDieError as e:
         logging.error(e)
         failed_tests.append(binary)
   else:
@@ -1082,7 +1082,7 @@ def RunTestsMain(options, args):
   # and '-c' and 'Release' are build options.
   targets = []
   build_options = []
-  for i in xrange(len(args)):
+  for i in range(len(args)):
     if args[i].startswith('-'):
       # starting with build options
       build_options = args[i:]
@@ -1190,14 +1190,14 @@ def CleanMain(options, unused_args):
 
 def ShowHelpAndExit():
   """Shows the help message."""
-  print 'Usage: build_mozc.py COMMAND [ARGS]'
-  print 'Commands: '
-  print '  gyp          Generate project files.'
-  print '  build        Build the specified target.'
-  print '  runtests     Build all tests and run them.'
-  print '  clean        Clean all the build files and directories.'
-  print ''
-  print 'See also the comment in the script for typical usage.'
+  print('Usage: build_mozc.py COMMAND [ARGS]')
+  print('Commands: ')
+  print('  gyp          Generate project files.')
+  print('  build        Build the specified target.')
+  print('  runtests     Build all tests and run them.')
+  print('  clean        Clean all the build files and directories.')
+  print('')
+  print('See also the comment in the script for typical usage.')
   sys.exit(1)
 
 
diff --git a/src/build_tools/android_util.py b/src/build_tools/android_util.py
index 5ea3da31..447ee781 100644
--- a/src/build_tools/android_util.py
+++ b/src/build_tools/android_util.py
@@ -548,7 +548,7 @@ def GetAvailableEmulatorPorts(android_home):
   (devices_result, _) = process.communicate()
   used_ports = set(int(port) for port
                    in re.findall(r'emulator-(\d+)', devices_result))
-  return [port for port in xrange(5554, 5586, 2) if port not in used_ports]
+  return [port for port in range(5554, 5586, 2) if port not in used_ports]
 
 
 def SetUpTestingSdkHomeDirectory(dest_android_sdk_home,
@@ -575,7 +575,7 @@ def SetUpTestingSdkHomeDirectory(dest_android_sdk_home,
           'create', 'avd',
           '--force',
           '--sdcard', '512M',]
-  for key, value in options.iteritems():
+  for key, value in options.items():
     args.extend([key, value])
   env = {'ANDROID_SDK_HOME': os.path.abspath(dest_android_sdk_home)}
   logging.info('Creating AVD: %s', args)
@@ -615,7 +615,7 @@ def GetAvdProperties(android_sdk_home, avd_name, my_open=open):
 def main():
   for arg in sys.argv[1:]:
     for item in sorted(GetApkProperties(arg).items()):
-      print '%s: %s' % item
+      print('%s: %s' % item)
 
 
 if __name__ == '__main__':
diff --git a/src/build_tools/binary_size_checker.py b/src/build_tools/binary_size_checker.py
index e53dc177..0f5e8b25 100644
--- a/src/build_tools/binary_size_checker.py
+++ b/src/build_tools/binary_size_checker.py
@@ -70,12 +70,12 @@ def CheckFileSize(filename):
   actual_size = os.stat(filename).st_size
   expected_size = EXPECTED_MAXIMUM_SIZES[basename]
   if actual_size < expected_size * 1024 * 1024:
-    print 'Pass: %s (size: %d) is smaller than expected (%d MB)' % (
-        filename, actual_size, expected_size)
+    print('Pass: %s (size: %d) is smaller than expected (%d MB)' % (
+        filename, actual_size, expected_size))
     return True
   else:
-    print 'WARNING: %s (size: %d) is larger than expected (%d MB)' % (
-        filename, actual_size, expected_size)
+    print('WARNING: %s (size: %d) is larger than expected (%d MB)' % (
+        filename, actual_size, expected_size))
     return False
 
 
diff --git a/src/build_tools/build_and_sign_pkg_mac.py b/src/build_tools/build_and_sign_pkg_mac.py
index 59a1f70f..1cced535 100644
--- a/src/build_tools/build_and_sign_pkg_mac.py
+++ b/src/build_tools/build_and_sign_pkg_mac.py
@@ -44,8 +44,8 @@ import os
 import shutil
 import sys
 
-from util import PrintErrorAndExit
-from util import RunOrDie
+from .util import PrintErrorAndExit
+from .util import RunOrDie
 
 
 def ParseOption():
diff --git a/src/build_tools/build_breakpad.py b/src/build_tools/build_breakpad.py
index 291c8ae0..92fee9d7 100644
--- a/src/build_tools/build_breakpad.py
+++ b/src/build_tools/build_breakpad.py
@@ -54,9 +54,9 @@ def ProcessCall(command):
   try:
     subprocess.check_output(command)
   except subprocess.CalledProcessError as e:
-    print e.output
+    print(e.output)
     sys.exit(e.returncode)
-  print 'Done: %s' % ' '.join(command)
+  print('Done: %s' % ' '.join(command))
 
 
 def Xcodebuild(projdir, target, arch, sdk, outdir):
diff --git a/src/build_tools/build_diskimage_mac.py b/src/build_tools/build_diskimage_mac.py
index f31c490b..8fa56aea 100644
--- a/src/build_tools/build_diskimage_mac.py
+++ b/src/build_tools/build_diskimage_mac.py
@@ -90,7 +90,7 @@ def main():
   # setup volume directory
   temp_dir = tempfile.mkdtemp()
   CopyFile(path.join(build_dir, ".keystone_install"), temp_dir)
-  os.chmod(path.join(temp_dir, ".keystone_install"), 0755) # rwxr-xr-x
+  os.chmod(path.join(temp_dir, ".keystone_install"), 0o755) # rwxr-xr-x
   for a in args:
     CopyFile(path.join(build_dir, a), temp_dir)
 
diff --git a/src/build_tools/change_reference_mac.py b/src/build_tools/change_reference_mac.py
index de11b7bd..6e8b1735 100644
--- a/src/build_tools/change_reference_mac.py
+++ b/src/build_tools/change_reference_mac.py
@@ -41,8 +41,8 @@ __author__ = "horo"
 import optparse
 import os
 
-from util import PrintErrorAndExit
-from util import RunOrDie
+from .util import PrintErrorAndExit
+from .util import RunOrDie
 
 
 def ParseOption():
